
itcl_class kdBase {
    public x            100
    public y            50
    public w            ""
    public editor       ""
    public item         0  {$editor setItem $item $this}
    public objid        0  {set oidthis($objid) $this}
    public interactive  1
    public name         ""
    public class
    public style
    protected mx
    protected my
    protected selection ""
    protected conn      ""
    protected finished  0
    protected findTags  ""
    # !!! diagram/editor
    protected ddd
    common oidthis

    constructor {config} {
	set oidthis($objid) $this
	# !!!
	catch {set ddd [$editor info protected diag -value]}
    }
    destructor { 
	if { $selection != "" } {
	    $selection delete
	}
	catch { 
	    $w delete $item 
	    $w delete added$item
	    $editor setItem $item
	}
	if $objid {
	    #$editor toDelete $objid
	}
    }
    method createImage st {
	$editor setItem $item $this
	set ddd [$editor info protected diag -value]
    }
    method destroy {} {
	foreach o [finish] {
	    $o delete
	}
    }
    method finish {} {
	if $finished {
	    return ""
	} else {
	    set finished 1
	    if $objid {
		#$editor toDelete $objid
	    }
	    set l ""
	    foreach spoj $conn {
		lappend l [$spoj finish]
	    }
	    return [eval concat $l $this]
	}
    }
    method configure {config} {}
    method get {com} {
	return [virtual subst $com]
    }
    method getItem {atr} {
	global kdPriv
	kdDBTuple "select $atr from $class \
		where name = '$name'"
    }
    method hasTag tag {
	return [expr [lsearch $findTags $tag] >= 0]
    }
    method addConn {connection} {
	lappend conn $connection
    }
    method removeConn {connection} {
	set i [lsearch $conn $connection]
	if {$i >= 0} {  
	    set conn [lreplace $conn $i $i]
	}
    }
    method addf_Tags {from to} {
	$w itemconfigure $to -tags [concat [$w gettags $to] \
		[regFilter f_* [$w gettags $from]]]
		
    }	

    method mark {X Y} {
	$editor setVar current $this
	set mx $X
	set my $Y
    }
    method drag {X Y} {
	set dx [expr $X - $mx] 
	set dy [expr $Y - $my]
	virtual move $dx $dy
	set mx $X
	set my $Y
    }
    method move {dx dy {whole 1}} {
	$w move $item $dx $dy
	set x [expr $x+$dx]
	set y [expr $y+$dy]
	$w move added$item $dx $dy
	if { $selection != "" } {
	    $selection move $dx $dy
	}
	if $whole {
	    foreach spoj $conn {
		$spoj move $dx $dy
	}   }
    }
    method call_xy {co X Y} {
	virtual $co [$w canvasx $X] [$w canvasy $Y]
    }
    method switchSelect {} {
	if {$selection == ""} {
	    virtual select
	} else {
	    virtual deselect
	}
    }
    method select {} {
    }	
    method deselect {} {
	catch { $selection delete }
	set selection ""
    }
    method modify {} {
	# if {$objid == 0} ...
	regsub -all "\[ \t\n\]" $name "" n
	modify_object $class $n
    }
}


itcl_class kdBox {
    inherit kdBase

    constructor {config} {
	global kdModel
	eval $kdModel(constr,$class)
    }
    method createImage st {
	global kdModel
	set style $kdModel(style,$class,$st)
	eval $kdModel(create,$class,$style)
	set added [$w create text $x $y -justify center -anchor c \
		-text $name -tags "added$item a_name$item"]
	addf_Tags $item $added
	$w addtag cl_box withtag $item
	$w addtag obj withtag $item
	previous createImage $st
    }
    method edit {} {
	set name [string trim [kdEntryBox .e $class \
		"Name:" $name]]
	$w itemconfig a_name$item -text $name
    }
    method intersec {line -xx -yy} {
	global kdModel
	upvar ${-xx} xx
	upvar ${-yy} yy
	if [info exists kdModel(intersec,$class)] {
	    eval $kdModel(intersec,$class)
	} else {
	    kdIntersecRec [$w coords $item] $line xx yy
	}
    }
    method select {} {
	set selection [sel_rec #auto [$w bbox $item] \
		-x $x -y $y -w $w -editor $editor -owner $item]
    }	
    method get_vals {} {
	return [list '$name' [expr int($x)] [expr int($y)]]
    }
    proc get_vnames {} {
	return {name x y}
    }
    method getLines {} {
	return $conn
    }
    proc getType {} {
	return b
    }
}


itcl_class kdLine {
    inherit kdBase

    public druh ""
    public coords 
    public boxBeg
    public boxEnd
    protected index

#    common druh_napojeni 
#    array set druh_napojeni { \
#	    1:1,zac napojeni 1:1,kon napojeni \
#	    1:n,zac napojeni 1:n,kon nap_op \
#	    m:n,zac napn m:n,kon napn \
#	    optional,zac nap_op optional,kon nap_op }
#    common omezeni 
#    array set omezeni { \
#	    1:1,zac entita 1:1,kon atribut \
#	    1:n,zac entita 1:n,kon entita \
#	    m:n,zac entita m:n,kon entita \
#	    optional,zac entita optional,kon entita }
	    
    constructor {config} {
	global druh_relace
#	if {$druh == ""} {
#	    set druh $druh_relace
#	}
	if $interactive {
	    #set boxBeg [$editor findFirst $x $y $omezeni($druh,zac)]
	    # if {$boxBeg == -1 } 
	    # set finished 1
	    # after idle $this delete
	    # # !!!
	    # return
	    # 
	} else {
	    # nacteni z databaze
	    #set item [eval $w create line $coords \
		    # -width 2 -tags {{f_move f_select cl_line obj}}]
    	}
	set findTags cara
    }
    method createImage st {
	global kdModel
	set style $kdModel(style,$class,$st)
	eval $kdModel(create,$class,$style)
	previous createImage $st
    }

#    method createNext {X Y} {
#	drag $X $Y 
#	set boxEnd [$editor findFirst $X $Y $omezeni($druh,kon)] 
#	if { $boxEnd == -1 } {
#	    # pokracujem dale
#	    eval $w coords $item $X $Y  [$w coords $item]
#	} else {
#	    # koncime
#	    set coords [$w coords $item] 
#	    set pocet [llength $coords]

#	    $boxBeg intersec [swap_coords [lrange $coords \
#		    [expr $pocet-4] [expr $pocet-1]]] x y
#	    eval $w coords $item [lreplace $coords [expr $pocet-2] \
#		    [expr $pocet-1] $x $y]
#	    $w itemconfigure $item -width 2 \
#		    -tags {f_move f_select cl_line obj}
#	    # $w lower $item $boxEnd
#	    # $w lower $item $boxBeg

#	    $boxEnd intersec [lrange $coords 0 3] X Y
#	    drag $X $Y
#	    set boxEnd [$ddd new $druh_napojeni($druh,kon) \
#		    -editor $editor -w $w -x $X -y $Y \
#		    -conBox $boxEnd \
#		    -conLine $this -ind 0]
#	    set boxBeg [$ddd new $druh_napojeni($druh,zac) \
#		    -editor $editor -w $w -x $x -y $y \
#		    -conBox $boxBeg \
#		    -conLine $this -ind -1]
#	    set conn "$boxEnd $boxBeg"
#	    kdRestoreBind $w {<Motion> <3> <1>}
#    }   }

#    method createCancel {X Y} {
#	set coords [$w coords $item]
#	if { [llength $coords] > 4 } then {
#	    # smazeme predposledni
#	    eval $w coords $item [lreplace $coords 2 3]
#	} else {  
#	    # rusime
#	    kdRestoreBind $w {<Motion> <3> <1>}
#	    # !!!
#	    set finished 1
#	    $this delete
#    }   }

    method move {dx dy {whole 1}} {
	if $whole {
	    # !!!
	    if {$index != "no"} {
		kdMovePart $dx $dy $w $item $index
	    }
	} else {
	    previous move $dx $dy 0
	}
    }   
    method move_one {dx dy idx} {
	kdMovePart $dx $dy $w $item $idx
	set coords [$w coords $item]
    }
    proc get_vnames {} {
	return {druh coords}
    }
    method get_vals {} {
	return [list '$druh' '[$w coords $item]']
    }
    method getBoxes {} {
	return $conn
    }
    proc getType {} {
	return l
    }
    method mark {X Y} {
	previous mark $X $Y
	set index [kdNearest $X $Y [$w coords $item]]
    }	
    method select {} {
	set selection [sel_line #auto [$w coords $item] \
		-x $x -y $y -w $w -editor $editor -owner $item]
    }
}


itcl_class kdConn {
    inherit kdBase

    public conBox
    public conLine
    public ind

    constructor {config} {
	global kdModel
	catch {eval $kdModel(constr,$class)}
	if {! $interactive} {
	    #nacteno z databaze
	    set conBox $oidthis($conBox)
	    set conLine $oidthis($conLine)
	}
	$conBox addConn $this 
	$conLine addConn $this 
    }
    method createImage st {
	global kdModel
	set style $kdModel(style,$class,$st)
	eval $kdModel(create,$class,$style)
	$w addtag cl_conn withtag $item
	$w addtag obj withtag $item
	previous createImage $st
    }
    method finish {} {
	if $finished {
	    return [previous finish]
	} else {
	    $conBox removeConn $this
	    $conLine removeConn $this
	    return [concat [previous finish] [$conLine finish]]
	}
    }
    method move {dx dy {whole 1}} {
	previous move $dx $dy $whole
	if $whole { 
	    $conLine move_one $dx $dy $ind 
	}
    }
    proc get_vnames {} {
	return {x y conBox conLine ind}
    }
    method get_vals {} {
	return [list [expr int($x)] [expr int($y)]\
		[$conBox get {$objid}] \
		[$conLine get {$objid}] $ind]
    }
    method getBox {} {
	return $conBox
    }
    method getLine {} {
	return $conLine
    }
    proc getType {} {
	return c
    }
}

